import pandas as pd
import numpy as np
from sklearn.preprocessing import StandardScaler,MinMaxScaler
from sklearn.neighbors import KNeighborsRegressor
from sklearn.ensemble import AdaBoostRegressor


from tensorflow.keras import Sequential,layers,losses,utils,Input
from tensorflow.keras.layers import Dense,LSTM,Dropout,concatenate,Flatten, Conv1D, MaxPooling1D,Activation,RepeatVector,TimeDistributed
import tensorflow as tf
# from tensorflow.keras.callbacks import ModelCheckpoint,TensorBoard
from tensorflow.keras.models import Model
# from tensorflow.keras.layers import Bidirectional,GRU,Lambda,Dot,Concatenate
from sklearn.metrics import mean_absolute_error,r2_score,mean_squared_error,mean_absolute_percentage_error
from keras.layers import Bidirectional,LSTM,GRU,Lambda,Dot,Concatenate

import matplotlib.pyplot as plt
import matplotlib

from keras.callbacks import ReduceLROnPlateau,ModelCheckpoint
from keras import optimizers
from keras.models import load_model

# 读取训练集
dushendux_train=pd.read_csv('shendux_train.csv')
dushendux_train1=np.array(dushendux_train)
dushendux_train2=np.reshape(dushendux_train1,(-1,120,7))

dushenduy_train=pd.read_csv('shenduy_train.csv')
dushenduy_train2=np.array(dushenduy_train)
# 读取测试集
dushendux_test=pd.read_csv('shendux_test.csv')
dushendux_test1=np.array(dushendux_test)
dushendux_test2=np.reshape(dushendux_test1,(-1,120,7))

dushenduy_test=pd.read_csv('shenduy_test.csv')
dushenduy_test2=np.array(dushenduy_test)

# # # 构造批数据
def create_batch_dataset(x,y,train=True,buffer_size=1000,batch_size=128):#buffer_size=1000表示可以打乱窗口里面的数据
    batch_data=tf.data.Dataset.from_tensor_slices((tf.constant(x),tf.constant(y)))#数据封装，tensor类型
    if train:
        return batch_data.cache().shuffle(buffer_size).batch(batch_size)
    else:
        return batch_data.batch(batch_size)

train_data_single=create_batch_dataset(dushendux_train2, dushenduy_train2,train=True)
val_data_single=create_batch_dataset(dushendux_test2,dushenduy_test2,train=False)



time_steps=120
input_dim=8
model_input=Input(shape=(time_steps,input_dim))
bilstm1=Bidirectional(LSTM(128,dropout=0.1,return_sequences=True))(model_input)
bilstm2=Bidirectional(LSTM(64,dropout=0.1))(bilstm1)
den1=Dense(1)(bilstm2)
bilstm_model=Model(model_input,den1)
adaa=optimizers.Adam(lr=0.0005)
bilstm_model.compile(optimizer=adaa, loss='mse',metrics='mae')# metrics=['accuracy']
bilstm_model_history = bilstm_model.fit(train_data_single, validation_data=val_data_single,epochs=1500, verbose=1)
bilstm_pred=bilstm_model.predict(dushendux_test2,verbose=1)
bilstm_pred1 = bilstm_pred*(bilstm_pred>=0)
bilstmr=r2_score(dushenduy_test2,bilstm_pred1)

maxmin=[662.0,3.0]
labels= np.array(dushenduy_test2)
for k in range(labels.shape[1]):
    labels[:, k] = labels[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
# 反归一化
bilstm_pred1= np.array(bilstm_pred1)  # 转换为numpy形式
bilstm_pred1= bilstm_pred1.reshape((-1,1))
bilstm_pred_len= bilstm_pred1.shape[1]
for k in range(bilstm_pred_len):
    bilstm_pred1[:, k] = bilstm_pred1[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

pd.DataFrame(bilstm_model_history.history).to_csv('Bi-lstm_history.csv', index=False)
bilstm_data=pd.DataFrame(bilstm_pred1,columns=['bi-lstm_pred'])
bilstm_data.to_csv('Bi-LSTM_pred.csv',index=False)

blstm_model_history=pd.read_csv('Bi-lstm_history.csv')
blstm_pre=pd.read_csv('Bi-LSTM_pred.csv')
blstm_rmse=np.sqrt(mean_squared_error(labels,bilstm_pred1))
blstm_mae=mean_absolute_error(labels,bilstm_pred1)

# 画图
plt.figure(figsize=(12,6))
plt.rcParams['font.sans-serif']=['Fangsong']
plt.rcParams['axes.unicode_minus']=False
plt.grid(color="k", linestyle=":")
plt.plot(blstm_model_history['val_loss'],label=['Bi-LSTM_loss_value'],color='k')
plt.xlabel('number',fontsize=25)
plt.ylabel('Bi-LSTM_loss_value',fontsize=25)
plt.xticks(fontsize=20)
plt.yticks(fontsize=20)
plt.rcParams['xtick.direction'] = 'in'
plt.rcParams['ytick.direction'] = 'in'
plt.legend(fontsize=20)
plt.savefig("Bi-LSTM损失图.jpg")
plt.show()

plt.figure(figsize=(18, 6))
ax = plt.subplot()
plt.rcParams['font.sans-serif']=['FangSong']
plt.rcParams['axes.unicode_minus']=False
plt.grid(color="k", linestyle=":")
ax.set_title('Bi-LSTM model',fontsize=25)
x = range(0,500,1)
plt.plot(x,labels[0:500],"k:", label="real", alpha=0.8,ms=10)
plt.plot(x,blstm_pre[0:500], "k-", label="pred", alpha=0.9,ms=10)
plt.xlabel('time/h',fontsize=25)
plt.ylabel('PM2.5/(ug/m^3)',fontsize=25)
plt.tick_params(labelsize=20)
plt.legend(loc='upper right',fontsize=20)
plt.savefig("Bi-LSTM拟合图500.jpg")