import pandas as pd
import numpy as np
from sklearn.ensemble import GradientBoostingRegressor
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')
# GBRT
Gbrt_model= GradientBoostingRegressor(learning_rate=0.1,loss='squared_error',n_estimators=100,min_samples_split=2,min_samples_leaf=1,max_depth=3)
Gbrt_model.fit(dujiqix_train,dujiqiy_train)
gbrty_pres=Gbrt_model.predict(dujiqix_test)
gbrty_modify = gbrty_pres*(gbrty_pres>=0)
gbrtr=r2_score(dujiqiy_test,gbrty_modify)
maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
gpreds = np.array(gbrty_modify)  # 转换为numpy形式
gpreds= gpreds.reshape((-1,1))
gfuture_len= gpreds.shape[1]
for k in range(gfuture_len):
    gpreds[:, k] = gpreds[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
g_rmse=np.sqrt(mean_squared_error(label,gpreds))
g_mae=mean_absolute_error(label,gpreds)
print(gbrtr)