import pandas as pd
import numpy as np
from sklearn.svm import SVR
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')

svr_rbf2 = SVR(kernel='linear', C=10, gamma=1)
svr_rbf2.fit(dujiqix_train,dujiqiy_train)
svry_pred2= svr_rbf2.predict(dujiqix_test)
svry_modify2 = svry_pred2*(svry_pred2>=0)
svrr2=r2_score(dujiqiy_test,svry_modify2)

maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
svrpreds = np.array(svry_modify2)  # 转换为numpy形式
svrpreds= svrpreds.reshape((-1,1))
svrfuture_len= svrpreds.shape[1]
for k in range(svrfuture_len):
    svrpreds[:, k] = svrpreds[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

svr_rmse=np.sqrt(mean_squared_error(label,svrpreds))
svr_mae=mean_absolute_error(label,svrpreds)
print(svrr2)