import pandas as pd
import numpy as np
from xgboost import XGBRegressor
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')
other_params1 = {'learning_rate': 0.1, 'n_estimators': 75, 'max_depth': 4, 'min_child_weight': 5,
                     'colsample_bytree': 0.7, 'gamma': 0.01,
                 }
xgb_model=XGBRegressor(**other_params1)
xgb_model.fit(dujiqix_train,dujiqiy_train)
xgby_pred=xgb_model.predict(dujiqix_test)
xgby_modify = xgby_pred*(xgby_pred>=0)
xgbr=r2_score(dujiqiy_test,xgby_modify)

maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
xgbpreds = np.array(xgby_modify)  # 转换为numpy形式
xgbpreds= xgbpreds.reshape((-1,1))
xfuture_len= xgbpreds.shape[1]
for j in range(xfuture_len):
    xgbpreds[:, j] = xgbpreds[:, j] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

xg_rmse=np.sqrt(mean_squared_error(label,xgbpreds))
xg_mae=mean_absolute_error(label,xgbpreds)
print(xgbr)