import pandas as pd
import numpy as np
from sklearn.neighbors import KNeighborsRegressor
from sklearn.ensemble import AdaBoostRegressor
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score
from sklearn.tree import DecisionTreeRegressor

# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')
#adaboost
Ada_model=AdaBoostRegressor(DecisionTreeRegressor(max_depth=11, min_samples_split=35, min_samples_leaf=35),
                            n_estimators=50,learning_rate=0.1,loss='linear')
Ada_model.fit(dujiqix_train,dujiqiy_train)
aday_pres=Ada_model.predict(dujiqix_test)
aday_modify = aday_pres*(aday_pres>=0)
adar=r2_score(dujiqiy_test,aday_modify)
maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
apreds = np.array(aday_modify)  # 转换为numpy形式
apreds= apreds.reshape((-1,1))
afuture_len= apreds.shape[1]
for k in range(afuture_len):
    apreds[:, k] = apreds[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
a_rmse=np.sqrt(mean_squared_error(label,apreds))
a_mae=mean_absolute_error(label,apreds)
print(adar)