import pandas as pd
import numpy as np
from sklearn.preprocessing import StandardScaler,MinMaxScaler
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsRegressor
from sklearn.ensemble import AdaBoostRegressor
from sklearn.tree import DecisionTreeRegressor

from tensorflow.keras import Sequential,layers,losses,utils,Input
from tensorflow.keras.layers import Dense,LSTM,Dropout,concatenate,Flatten, Conv1D, MaxPooling1D,Activation,RepeatVector,TimeDistributed
import tensorflow as tf
# from tensorflow.keras.callbacks import ModelCheckpoint,TensorBoard
from tensorflow.keras.models import Model
# from tensorflow.keras.layers import Bidirectional,GRU,Lambda,Dot,Concatenate
from sklearn.metrics import mean_absolute_error,r2_score,mean_squared_error,mean_absolute_percentage_error
from keras.layers import Bidirectional,LSTM,GRU,Lambda,Dot,Concatenate

import matplotlib.pyplot as plt
import matplotlib

from sklearn.decomposition import PCA
from keras.callbacks import ReduceLROnPlateau,ModelCheckpoint
from keras import optimizers
from keras.models import load_model

data_changping=pd.read_csv('changping.csv')
data_shunyi=pd.read_csv('shunyi.csv')
data_changping['shunyi_PM2.5']=data_shunyi['PM2.5']
data_changping.to_csv('hunhe1.csv',index=False)
data=pd.read_csv('hunhe1.csv')
col=[ 'year', 'month', 'day', 'hour', 'PM2.5', 'PM10', 'SO2', 'NO2',
       'CO', 'O3', 'TEMP', 'PRES', 'DEWP', 'RAIN',  'WSPM','wd','shunyi_PM2.5']
datacol=data[col]
# 直接删除缺失值
datashan=datacol.dropna()
datashan['datatime']=datashan['year'].map(str)+'-'+datashan['month'].map(str)+'-'+datashan['day'].map(str)+'-'+datashan['hour'].map(str)
datashan['datatime']=pd.to_datetime(datashan['datatime'],format='%Y-%m-%d-%H',errors='coerce')
datashan.index=datashan['datatime']
scale_mapper={'E':1, 'ENE':2, 'NNE':3, 'N':4, 'NNW':5, 'NW':6, 'NE':7, 'SW':8, 'SSW':9, 'WSW':10,
       'ESE':11, 'SE':12, 'S':13, 'WNW':14, 'SSE':15, 'W':16}
datashan['wd']=datashan['wd'].replace(scale_mapper)
chongcol=[ 'PM2.5', 'PM10', 'SO2', 'NO2', 'CO',
       'O3', 'TEMP', 'PRES', 'DEWP', 'RAIN', 'WSPM','wd','shunyi_PM2.5']
datag=datashan[chongcol]
datal=datashan[chongcol]

# 归一化
scaler = MinMaxScaler(feature_range=(0, 1))  # minmaxscaler 方法，用来做归一化
sel_col = datag.columns
# print(sel_col)
for col in sel_col:
    datag[col] = scaler.fit_transform(datag[col].values.reshape(-1, 1))  # reshape成为一列
 # 数据逆归一化
maxmin = [datal['PM2.5'].max(), datal['PM2.5'].min()]  # 原来的最大最小值，反放缩
# print(maxmin)
# print("Load dataset LEN: ", datag.shape[0])
# print(sel_col)
# PCA
X = []
Y = []
columns_name = list(datag.columns)
y_index = columns_name.index('PM2.5')
tmp = np.array(datag, dtype=np.float32)
# print("The shape of tmp is:")
# print(tmp.shape)
pca = PCA(n_components=0.97)
tmp2 = pca.fit_transform(tmp[:,1:])
# print("The shape of tmp2 is:")
# print(tmp2.shape)
# print("input dim is:")
# print(tmp2.shape[1])

seqX=120
seqY=1
day_delay=1
gap=1
X1=[]
for i in range(tmp2.shape[0] - (seqX+seqY+day_delay)*gap):
        # seqX, seqX+day_delay, seqX+day_delay+seqY
        # format: i+x*gap
        X.append(tmp2[i:(i + seqX*gap):gap, :])  # tmp2是PCA降维后的特征，如果是tmp那就是原始特征
        X1.append(tmp2[(i+seqX*gap): (i+(seqX+day_delay)*gap): gap,:])
#         Y.append(tmp[(i+(seqX+day_delay)*gap): (i+(seqX+day_delay+seqY)*gap): gap, y_index])
        Y.append(tmp[(i+seqX*gap): (i+(seqX+day_delay)*gap): gap, y_index])
X = np.array(X)
Y = np.array(Y)
X1=np.array(X1)

X = X.astype(np.float32)
Y = Y.astype(np.float32)
p = np.random.permutation(range(len(X)))
X,Y,X1 = X[p],Y[p],X1[p]

shendu_trainx, shendu_trainy = X[:int(0.9* 31792)], Y[:int(0.9 * 31792)]
jiqi_trainx, jiqi_trainy = X1[:int(0.9 * 31792)], Y[:int(0.9 * 31792)]
shendu_testx, shendu_testy = X[int(0.9 * 31792):], Y[int(0.9 * 31792):]
jiqi_testx, jiqi_testy = X1[int(0.9 * 31792):], Y[int(0.9 * 31792):]
realjiqi_trainx=jiqi_trainx.reshape(28612,8)
realjiqi_testx=jiqi_testx.reshape(3180,8)
# 保存深度学习训练测试数据
# 将训练集存起来
nptrainx=np.reshape(shendu_trainx,(-1,8))
pdtrainx1=np.reshape(nptrainx,(-1,120,8))
pdshendutrainx=pd.DataFrame(nptrainx,columns=['t1','t2','t3','t4','t5','t6','t7','t8'])
pdshendutrainx.to_csv('shendux_train.csv',index=False)
nptestx=np.reshape(shendu_testx,(-1,8))
pdshendux_test=pd.DataFrame(nptestx,columns=['t1','t2','t3','t4','t5','t6','t7','t8'])
pdshendux_test.to_csv('shendux_test.csv',index=False)
pdshenduy_train=pd.DataFrame(shendu_trainy,columns=['y1'])
pdshenduy_train.to_csv('shenduy_train.csv',index=False)
pdshenduy_test=pd.DataFrame(shendu_testy,columns=['y1'])
pdshenduy_test.to_csv('shenduy_test.csv',index=False)

# 保存机器学习训练测试集
pdjiqitrainx=pd.DataFrame(realjiqi_trainx,columns=['t1','t2','t3','t4','t5','t6','t7','t8'])
pdjiqitrainx.to_csv('jiqix_train.csv',index=False)
pdjiqitestx=pd.DataFrame(realjiqi_testx,columns=['t1','t2','t3','t4','t5','t6','t7','t8'])
pdjiqitestx.to_csv('jiqix_test.csv',index=False)
pdjiqiy_train=pd.DataFrame(jiqi_trainy,columns=['y1'])
pdjiqiy_train.to_csv('jiqiy_train.csv',index=False)
pdjiqiy_test=pd.DataFrame(jiqi_testy,columns=['y1'])
pdjiqiy_test.to_csv('jiqiy_test.csv',index=False)