import pandas as pd
import numpy as np
from sklearn.linear_model import LassoCV
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')

La=LassoCV()
La.fit(dujiqix_train,dujiqiy_train)
lay_predict=La.predict(dujiqix_test)
lay_modify = lay_predict*(lay_predict>=0)
rla=r2_score(dujiqiy_test,lay_modify)

maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
lapreds = np.array(lay_modify)  # 转换为numpy形式
lapreds= lapreds.reshape((-1,1))
lafuture_len= lapreds.shape[1]
for k in range(lafuture_len):
    lapreds[:, k] = lapreds[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

las_rmse=np.sqrt(mean_squared_error(label,lapreds))
las_mae=mean_absolute_error(label,lapreds)
print(rla)