import pandas as pd
import numpy as np
from sklearn.metrics import mean_absolute_error,r2_score,mean_squared_error,mean_absolute_percentage_error
import matplotlib.pyplot as plt

dushenduy_test=pd.read_csv('shenduy_test.csv')
dushenduy_test2=np.array(dushenduy_test)
maxmin=[662.0,3.0]
labels= np.array(dushenduy_test2)
for k in range(labels.shape[1]):
    labels[:, k] = labels[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

# 读取注意力机制数据
duquattlstm=pd.read_csv('LSTM-Attention_pred.csv')
lstmatt_wucha=np.absolute(labels-duquattlstm)
lstmatt_wucha=np.array(lstmatt_wucha)

duqulightGBM=pd.read_csv('lightGBM预测结果.csv')
LightGBM_wucha=np.absolute(labels-duqulightGBM)
LightGBM_wucha=np.array(LightGBM_wucha)
cha1=(LightGBM_wucha/(lstmatt_wucha+LightGBM_wucha))*duquattlstm
cha2=lstmatt_wucha/(lstmatt_wucha+LightGBM_wucha)*duqulightGBM
zhong_pre=np.array(cha1)+np.array(cha2)
print(r2_score(np.array(labels),zhong_pre))
print(mean_absolute_error(labels,zhong_pre))
print(np.sqrt(mean_squared_error(labels,zhong_pre)))

plt.figure(figsize=(18, 6))
ax = plt.subplot()
plt.rcParams['font.sans-serif']=['FangSong']
plt.rcParams['axes.unicode_minus']=False
plt.grid(color="k", linestyle=":")
ax.set_title('lightGBM+LSTM-Attention model',fontsize=25)
x = range(0,500,1)
plt.plot(x,labels[0:500],"k:", label="real", alpha=0.8,ms=10)
plt.plot(x,zhong_pre[0:500], "k-", label="pred", alpha=0.9,ms=10)
plt.xlabel('time/h',fontsize=25)
plt.ylabel('PM2.5/(ug/m^3)',fontsize=25)
plt.tick_params(labelsize=20)
plt.legend(loc='upper right',fontsize=20)
plt.savefig("lightGBM+LSTM-Attention拟合图500.jpg")


