import pandas as pd
import numpy as np
import lightgbm as lgb
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')

tmodel_lgb = lgb.LGBMRegressor(objective='regression',
                               num_leaves=30,learning_rate=0.01,n_estimators=500,
                               max_depth=8,metric='rmse',min_child_samples=5
                            )#reg_alpha=0.5,reg_lambda=0.5,feature_fraction=0.6,bagging_fraction=0.4,
tmodel_lgb.fit(dujiqix_train,dujiqiy_train)
lgby=tmodel_lgb.predict(dujiqix_test)
lgby_modify=lgby*(lgby>=0)
lgbr=r2_score(dujiqiy_test,lgby_modify)

maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
lpreds1 = np.array(lgby_modify)  # 转换为numpy形式
lpreds1= lpreds1.reshape((-1,1))
lfuture_len= lpreds1.shape[1]
for k in range(lfuture_len):
    lpreds1[:, k] = lpreds1[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

l_rmse=np.sqrt(mean_squared_error(label,lpreds1))
l_mae=mean_absolute_error(label,lpreds1)
lpreds1.to_csv('lightGBM预测结果.csv',index=False)
print(lgbr)