import pandas as pd
import numpy as np

from sklearn.ensemble import RandomForestRegressor
from sklearn.metrics import mean_absolute_error,mean_squared_error,r2_score


# 读取训练集
dujiqix_train=pd.read_csv('jiqix_train.csv')
dujiqiy_train=pd.read_csv('jiqiy_train.csv')
# 读取测试集
dujiqix_test=pd.read_csv('jiqix_test.csv')
dujiqiy_test=pd.read_csv('jiqiy_test.csv')
# print(dujiqiy_test)

# # 随机森林
rd=RandomForestRegressor(max_depth=11,max_features=6,min_samples_split=35,n_estimators=96,min_samples_leaf=9)     #基模型
rd.fit(dujiqix_train,dujiqiy_train)
suiy_pres=rd.predict(dujiqix_test)
yrand_modify = suiy_pres*(suiy_pres>=0)
# print(yrand_modify)
suijir=r2_score(dujiqiy_test,yrand_modify.reshape(-1,1))
maxmin=[662.0,3.0]
label = np.array(dujiqiy_test)
for k in range(1):
    label[:, k] = label[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
spreds = np.array(yrand_modify)  # 转换为numpy形式
spreds= spreds.reshape((-1,1))
sfuture_len= spreds.shape[1]
for k in range(sfuture_len):
    spreds[:, k] = spreds[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化
s_rmse=np.sqrt(mean_squared_error(label,spreds))
s_mae=mean_absolute_error(label,spreds)
print(suijir)