import pandas as pd
import numpy as np
from sklearn.metrics import mean_absolute_error,r2_score,mean_squared_error,mean_absolute_percentage_error
import matplotlib.pyplot as plt

dushenduy_test=pd.read_csv('shenduy_test.csv')
dushenduy_test2=np.array(dushenduy_test)
maxmin=[662.0,3.0]
labels= np.array(dushenduy_test2)
for k in range(labels.shape[1]):
    labels[:, k] = labels[:, k] * (maxmin[0] - maxmin[1]) + maxmin[1]  # 反归一化

# 读取注意力机制数据
duquattlstm=pd.read_csv('LSTM-Attention_pred.csv')
lstmatt_wucha=np.absolute(labels-duquattlstm)
lstmatt_wucha=np.array(lstmatt_wucha)

duqulightGBM=pd.read_csv('lightGBM预测结果.csv')
LightGBM_wucha=np.absolute(labels-duqulightGBM)
LightGBM_wucha=np.array(LightGBM_wucha)
cha1=(LightGBM_wucha/(lstmatt_wucha+LightGBM_wucha))*duquattlstm
cha2=lstmatt_wucha/(lstmatt_wucha+LightGBM_wucha)*duqulightGBM
zhong_pre=np.array(cha1)+np.array(cha2)


lstm=pd.read_csv('LSTM_pred.csv')
gru=pd.read_csv('GRU_pred.csv')
bilstm=pd.read_csv('Bi-LSTM_pred.csv')
lstmatt=pd.read_csv('LSTM-Att_pred.csv')


plt.figure(figsize=(22, 6))
ax = plt.subplot(111)
plt.rcParams['font.sans-serif']=['FangSong']
plt.rcParams['axes.unicode_minus']=False
plt.grid(color="k", linestyle=":")
ax.set_title('Model comparison',fontsize=25)
x = range(0,500,1)

ax.plot(x,labels[0:500], "k-*", linestyle='-',label="real", alpha=0.8,ms=7)
ax.plot(x,lstm[0:500], "#0072B2", linestyle='-',label="lstm-pred", alpha=1)
ax.plot(x,gru[0:500], "y", linestyle='-',label="gru-pred", alpha=1,linewidth=2)
ax.plot(x,bilstm[0:500], "#009E73",linestyle='-',label="bi-lstm-pred", alpha=1,ms=5)
ax.plot(x,lstmatt[0:500], "#CC79A7", linestyle='-',label="lstm-attention-pred", alpha=1,ms=5)
ax.plot(x,zhong_pre[0:500], ":o",c="#D55E00",label="lstm-attention+lightgbm-pred", alpha=0.8,ms=5)

plt.xlabel('time/h',fontsize=25)
plt.ylabel('PM2.5/(ug/m^3)',fontsize=25)
plt.xticks(fontsize=20)
plt.yticks(fontsize=20)
plt.rcParams.update({'font.size': 14})
plt.legend(fontsize=13)
plt.savefig("总体拟合图500.jpg")